#!/usr/bin/python
# -*- coding: utf-8 -*-
# Jens Dietrich 03.10.2021
# lesen Leistung und abschalten wenn unter 250 Watt
# Gesamt- und Tagesladung als Variablen in eine Datei schreiben
# es wird auch die Gesamtzahl der Ladungen gezaehlt

import sys, os, time, logging
logging.basicConfig(filename='unu.log', level=logging.INFO, format='%(asctime)s %(message)s', datefmt='%y.%m.%d %H:%M:%S ' )
total = 'unu_t.txt'                        # Gesamtwert aller Ladevorgaenge
current = 'unu_c.txt'                      # aktuelle Ladevorgang
count = 'unu_n.txt'                        # Gesamtzahl aller Ladevorgaenge

# Unterprogramme

def present(file):                         # Test ob die Datei 'file' existiert
  try:
    with open(file, 'r') as f:
      return True
  except:
    return False

def read ():                               # AVM Steckdosenaktor auslesen
  process = os.popen('sudo ./read.sh')
  str = process.read()
  process.close()
  if not str:
    sys.exit(1)
  str = str.replace(',','.')
  str = str.replace('\n','')
  return str;

def switch_off():                          # AVM Steckdosenaktor abschalten
  process = os.popen('sudo ./off.sh')
  str = process.read()
  process.close()

# Programmstart Main

if(not(present(total))):                   # anlegen, wenn datei nicht existiert
  f = open(total,'w')
  f.write(str(0))
  f.close()

if(not(present(current))):
  f = open(current,'w')
  f.write(str(0))
  f.close()

if(not(present(count))):
  f = open(count,'w')
  f.write(str(0))
  f.close()

a = float(read()) * 0.01                  # steckdose auslesen

if (a > 250):
  f = open(total,'r')                     # zaehler total lesen
  w_t = float(f.read())
  f.close()

  f = open(current,'r')                   # zaehler aktuell lesen
  w_c = float(f.read())
  f.close()

  w_t = w_t + (a / 60)
  w_c = w_c + (a / 60)
  text = 'Gesamtsumme / Aktuell / Ladeleistung - ' + "%8.3f" % (w_t/1000) + ' KWh  ' + "%6.1f" % w_c + ' Wh  ' + "%3.0f" % a + ' Watt'
  print text
  logging.info (text)

  f = open(total,'w')                     # neuen zaehler total schreiben
  f.write(str(w_t))
  f.close()

  f = open(current,'w')                   # neuen zaehler aktuell schreiben
  f.write(str(w_c))
  f.close()

else:
  f = open(current,'r')                   # zaehler aktuell lesen
  w_c = float(f.read())
  f.close()

  if(not(w_c == 0)):
    w_c = 0
    f = open(current,'w')                 # zaehler auf null
    f.write(str(w_c))
    f.close()

    f = open(count,'r')                   # Gesamtladezaehler lesen
    w_n = float(f.read())
    f.close()
    w_n = w_n + 1                         # incrementieren
    f = open(count,'w')                   # schreiben
    f.write(str(w_n))
    f.close()

    text = 'Laden beendet. Das war der ' + "%4.0f" % w_n + '. Akku-Ladevorgang'
    logging.info (text)

  switch_off()                            # abschalten

